// copyright (c) 2008 rajh and gregwar. Score stuff
#ifndef GAME_SERVER_SCORE_H
#define GAME_SERVER_SCORE_H

#include <engine/shared/protocol.h>

class PLAYER_SCORE
{
public:
	char name[MAX_NAME_LENGTH];
	float score;
	char ip[16];
	float cp_time[42];

	PLAYER_SCORE(const char *name, float score, const char *ip, float cp_time[42]);

	bool operator==(const PLAYER_SCORE& other) { return (this->score == other.score); }
	bool operator<(const PLAYER_SCORE& other) { return (this->score < other.score); }
};

class SCORE
{
	class CGameContext *m_pGameServer;
	class IServer *m_pServer;
	CGameContext *GameServer() const { return m_pGameServer; }
	IServer *Server() const { return m_pServer; }

public:
	SCORE();

	void init(class CGameContext *pGameServer);
	void save();
	void load();
	PLAYER_SCORE *search_score(int id, bool score_ip, int *position);
	PLAYER_SCORE *search_name(const char *name, int *position, bool match_case);
	void parsePlayer(int id, float score, float cp_time[42]);
	void initPlayer(int id);
	void top5_draw(int id, int debut);
};

#endif
